| OpenCV 5.0.0alpha Open Source Computer Vision

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
cv::DownhillSolver Class Referenceabstract
Core functionality » Optimization Algorithms

This class is used to perform the non-linear non-constrained minimization of a function,. More...

`#include <opencv2/core/optim.hpp>`

Collaboration diagram for cv::DownhillSolver:

## Public Member Functions
virtual void | getInitStep (OutputArray step) const =0
| Returns the initial step that will be used in downhill simplex algorithm.
virtual void | setInitStep (InputArray step)=0
| Sets the initial step that will be used in downhill simplex algorithm.
Public Member Functions inherited from cv::MinProblemSolver
virtual Ptr< Function > | getFunction () const =0
| Getter for the optimized function.
virtual TermCriteria | getTermCriteria () const =0
| Getter for the previously set terminal criteria for this algorithm.
virtual double | minimize (InputOutputArray x)=0
| actually runs the algorithm and performs the minimization.
virtual void | setFunction (const Ptr< Function > &f)=0
| Setter for the optimized function.
virtual void | setTermCriteria (const TermCriteria &termcrit)=0
| Set terminal criteria for solver.
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state.
virtual bool | empty () const
| Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read.
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage.
virtual void | save (const String &filename) const
virtual void | write (FileStorage &fs) const
| Stores algorithm parameters in a file storage.
void | write (FileStorage &fs, const String &name) const

## Static Public Member Functions
static Ptr< DownhillSolver > | create (const Ptr< MinProblemSolver::Function > &f=Ptr< MinProblemSolver::Function >(), InputArray initStep=Mat_< double >(1, 1, 0.0), TermCriteria termcrit=TermCriteria(TermCriteria::MAX_ITER+TermCriteria::EPS, 5000, 0.000001))
| This function returns the reference to the ready-to-use DownhillSolver object.
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file.
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String.
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node.

## Additional Inherited Members
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

This class is used to perform the non-linear non-constrained minimization of a function,.

defined on an `n`-dimensional Euclidean space, using the Nelder-Mead method, also known as downhill simplex method**. The basic idea about the method can be obtained from http://en.wikipedia.org/wiki/Nelder-Mead_method.

It should be noted, that this method, although deterministic, is rather a heuristic and therefore may converge to a local minima, not necessary a global one. It is iterative optimization technique, which at each step uses an information about the values of a function evaluated only at `n+1` points, arranged as a simplex in `n`-dimensional space (hence the second name of the method). At each step new point is chosen to evaluate function at, obtained value is compared with previous ones and based on this information simplex changes it's shape , slowly moving to the local minimum. Thus this method is using only function values to make decision, on contrary to, say, Nonlinear Conjugate Gradient method (which is also implemented in optim).

Algorithm stops when the number of function evaluations done exceeds termcrit.maxCount, when the function values at the vertices of simplex are within termcrit.epsilon range or simplex becomes so small that it can enclosed in a box with termcrit.epsilon sides, whatever comes first, for some defined by user positive integer termcrit.maxCount and positive non-integer termcrit.epsilon.

Note
  DownhillSolver is a derivative of the abstract interface cv::MinProblemSolver, which in turn is derived from the Algorithm interface and is used to encapsulate the functionality, common to all non-linear optimization algorithms in the optim module.
  term criteria should meet following condition:
  termcrit.type == (TermCriteria::MAX_ITER + TermCriteria::EPS) && termcrit.epsilon > 0 && termcrit.maxCount > 0
  cv::TermCriteria::MAX_ITER
  @ MAX_ITER
  ditto
  Definition types.hpp:904
  cv::TermCriteria::EPS
  @ EPS
  the desired accuracy or change in parameters at which the iterative algorithm stops
  Definition types.hpp:905

## Member Function Documentation

## ◆ create()

static Ptr< DownhillSolver > cv::DownhillSolver::create | ( | const Ptr< MinProblemSolver::Function > & | f = Ptr< MinProblemSolver::Function >(),
|  | InputArray | initStep = Mat_< double >(1, 1, 0.0),
|  | TermCriteria | termcrit = TermCriteria(TermCriteria::MAX_ITER+TermCriteria::EPS, 5000, 0.000001) )
| static

This function returns the reference to the ready-to-use DownhillSolver object.

All the parameters are optional, so this procedure can be called even without parameters at all. In this case, the default values will be used. As default value for terminal criteria are the only sensible ones, MinProblemSolver::setFunction() and DownhillSolver::setInitStep() should be called upon the obtained object, if the respective parameters were not given to create(). Otherwise, the two ways (give parameters to createDownhillSolver() or miss them out and call the MinProblemSolver::setFunction() and DownhillSolver::setInitStep()) are absolutely equivalent (and will drop the same errors in the same way, should invalid input be detected).

Parameters

  f | Pointer to the function that will be minimized, similarly to the one you submit via MinProblemSolver::setFunction.
  initStep | Initial step, that will be used to construct the initial simplex, similarly to the one you submit via MinProblemSolver::setInitStep.
  termcrit | Terminal criteria to the algorithm, similarly to the one you submit via MinProblemSolver::setTermCriteria.

## ◆ getInitStep()

virtual void cv::DownhillSolver::getInitStep | ( | OutputArray | step | ) | const
| pure virtual

Returns the initial step that will be used in downhill simplex algorithm.

Parameters

  step | Initial step that will be used in algorithm. Note, that although corresponding setter accepts column-vectors as well as row-vectors, this method will return a row-vector.

See also
  DownhillSolver::setInitStep

## ◆ setInitStep()

virtual void cv::DownhillSolver::setInitStep | ( | InputArray | step | ) |
| pure virtual

Sets the initial step that will be used in downhill simplex algorithm.

Step, together with initial point (given in DownhillSolver::minimize) are two `n`-dimensional vectors that are used to determine the shape of initial simplex. Roughly said, initial point determines the position of a simplex (it will become simplex's centroid), while step determines the spread (size in each dimension) of a simplex. To be more precise, if \(s,x_0\in\mathbb{R}^n\) are the initial step and initial point respectively, the vertices of a simplex will be: \(v_0:=x_0-\frac{1}{2} s\) and \(v_i:=x_0+s_i\) for \(i=1,2,\dots,n\) where \(s_i\) denotes projections of the initial step of n-th coordinate (the result of projection is treated to be vector given by \(s_i:=e_i\cdot\left<e_i\cdot s\right>\), where \(e_i\) form canonical basis)

Parameters

  step | Initial step that will be used in algorithm. Roughly said, it determines the spread (size in each dimension) of an initial simplex.

The documentation for this class was generated from the following file:

- opencv2/core/optim.hpp